
#include "aradengn.h"








FILE* f3;




int CheckPoint (double X1, double X2)
{
    const double MaxDiff = 0.0001;

    double Sum;

    Sum = fabs (X1 + X2)/2.0;

    if (Sum > 1.0e-25)
        if ((fabs (X1 - X2)/Sum) > MaxDiff)
        {
            printf ("Sum = %lf  X1 = %lf   X2 = %lf   Abs (X1-X2)/Sum = %lf \n",
                     Sum, X1, X2, fabs (X1-X2)/Sum);
            return (0);
        };

    return (1);
};







static void GetInt (FILE* f, int* X)
{

    fread (X, sizeof (int), 1, f);

};  /*  void GetInt  */








static void GetFloat (FILE* f, float* X)
{

    fread (X, sizeof (float), 1, f);

};  /*  void GetFloat  */








static void GetDouble (FILE* f, double* X)
{

    fread (X, sizeof (double), 1, f);

};  /*  void GetDouble  */









void CompareGrid (int GridCount, FILE *f, GridArray G)

{
    int i, j, NX, NY, NR;
    float X1, X2 = 0;
    double D1, D2;

    GetInt (f, &NX);
    GetInt (f, &NY);
    GetInt (f, &NR);

    GetDouble (f, &D1);
    GetDouble (f, &D2);

    for (i = 0; i< NX; i++)
        for (j = 0; j < NY; j++)
        {

            GetFloat (f, &X1);

            X2 = G [i][j];

            fprintf (f3, "%i %2i %2i %11.5f %11.5f \n", GridCount, i, j, X1, X2);
             
            if (! CheckPoint (X1, X2))
            {
                printf ("i, j = %i %i \n", i, j);
                FailExit ("Abort");
            };

        };

    for (i=0; i < NR; i++)
    {
        GetFloat (f, &X1);
        X2 = G [i][NY];
        CheckPoint (X1, X2);
    };

};








main (void)
{

    FILE* f1;
    FILE* f2;
    int HazCode;
    double T1, T2;
    double Height;
    double GRA;
    static GridArray G;
    int N, i;


    printf ("Opening hazscens.dat \n");

    f1 = fopen ("hazscens.dat", "r");

    if (! f1)
        FailExit ("ERROR - Could not open input file 'HAZSCENS.DAT'");


    printf ("Opening hazscens.grd \n");

    f2 = fopen ("hazscens.grd", "rb");

    if (! f2)
        FailExit ("ERROR - Could not open input file 'HAZSCENS.GRD'");


    printf ("Opening haztest.txt \n");

    f3 = fopen ("haztest.txt", "w");

    if (! f3)
        FailExit ("ERROR - Could not open output file 'HAZTEST.TXT'");


    printf ("Loading testcase.grd \n");

    ReadComputedGrids ("testcase.grd");


    printf ("Beginning to process grids \n");

    fscanf (f1, " %i", &N);

    for (i=1; i <= N; i++)
    {
        printf ("Processing grid %i \n", i);
        fscanf (f1, " %i %lf %lf %lf", &HazCode, &T1, &T2, &Height);
        ComputeHazard (HazCode, T1, T2, Height, 0, G, &GRA);
        CompareGrid (i, f2, G);
    };


    printf ("Closing files \n");

    fclose (f1);
    fclose (f2);
    fclose (f3);

    printf ("Done \n");

    wait;

    SuccessExit ();

    return (0);

};
