
/*  Misc. testing functions used during the translation of the Airrad 8.0
/*  computational engine from Borland Pascal to ANSI C.
/*
/**/




void TestHunt (void)
{

    double A [9] = {10.0, 20.0, 30.0, 40.0, 50.0, 60.0, 70.0, 80.0, 90.0};

    int Jlo = 99;

    double X;


    do
    {
        printf ("Enter X : ");
        scanf (" %lf", &X);

        if (X < 0.0) return;

        Hunt (A, 9, X, &Jlo);

        printf ("\n\n%4.1lf is between %4.1lf and %4.1lf \n\n\n",
                 X, A [Jlo], A [Jlo+1]);


    } while (X > 1.0);

};








void TestLI (void)
{

    double X [9] = {1, 2, 3, 4, 5, 6, 7, 8, 9};
    double Y [9] = {10.0, 20.0, 30.0, 40.0, 50.0, 60.0, 70.0, 80.0, 90.0};

    double Xeval;

    do
    {
        printf ("Enter Xeval : ");
        scanf (" %lf", &Xeval);

        if (Xeval < 0.0) return;

        printf ("\n\nY (%4.1lf) = %4.1lf \n\n\n",
                 Xeval, LinearInterpolate (X, Y, 9, Xeval));


    } while (1);

};








void TestSort (void)
{

    double X [10];
    int    n, i;

    do
    {

        printf ("Enter n : ");

        scanf (" %i", &n);

        for (i=0; i<n; i++)
        {
            printf ("   Enter point %i : ", i+1);
            scanf (" %lf", &(X [i]));
        };

        printf ("\n\n");
        printf ("Before sort = ");

        for (i=0; i<n; i++)
           printf ("%4.0lf", X[i]);

        printf ("\n\n");


        HeapSort (X, n, 0);


        printf ("After sort  = ");

        for (i=0; i<n; i++)
           printf ("%4.0lf", X[i]);

        printf ("\n\n");
    }
    while (n != 0);

    SuccessExit ();

};








double TestIntF (double X)
{
    return (X*X + 1);
};




void TestIntegrate (void)
{

    double X1, X2;

    do
    {
        printf ("Enter X1, X2: ");
        scanf (" %lf %lf", &X1, &X2);

        if (X1 < 0.0) return;

        printf ("\n\nIntegral (%4.1lf to %4.1f) = %7.2lf \n\n\n",
                 X1, X2, Integrate (TestIntF, X1, X2, 0.001, 0.001));

    } while (1);

};








